var TestUiTsLib = (function (Vue, elementUi, elementVariables_scss, VJsoneditor, common_scss, icons_scss, tslib, vuePropertyDecorator) {
  'use strict';

  var Vue__default = 'default' in Vue ? Vue['default'] : Vue;
  VJsoneditor = VJsoneditor && Object.prototype.hasOwnProperty.call(VJsoneditor, 'default') ? VJsoneditor['default'] : VJsoneditor;

  Vue__default.use(elementUi.Dialog);
  Vue__default.use(elementUi.Menu);
  Vue__default.use(elementUi.MenuItem);
  Vue__default.use(elementUi.Submenu);
  Vue__default.use(elementUi.Input);
  Vue__default.use(elementUi.InputNumber);
  Vue__default.use(elementUi.Radio);
  Vue__default.use(elementUi.RadioGroup);
  Vue__default.use(elementUi.Select);
  Vue__default.use(elementUi.Option);
  Vue__default.use(elementUi.Button);
  Vue__default.use(elementUi.ButtonGroup);
  Vue__default.use(elementUi.Table);
  Vue__default.use(elementUi.TableColumn);
  Vue__default.use(elementUi.DatePicker);
  Vue__default.use(elementUi.Form);
  Vue__default.use(elementUi.FormItem);
  Vue__default.use(elementUi.Tag);
  Vue__default.use(elementUi.Row);
  Vue__default.use(elementUi.Col);
  Vue__default.use(elementUi.Upload);
  Vue__default.use(elementUi.Card);
  Vue__default.use(elementUi.Container);
  Vue__default.use(elementUi.Header);
  Vue__default.use(elementUi.Aside);
  Vue__default.use(elementUi.Main);
  Vue__default.use(elementUi.Dropdown);
  Vue__default.use(elementUi.DropdownMenu);
  Vue__default.use(elementUi.DropdownItem);
  Vue__default.use(elementUi.Tooltip);
  Vue__default.use(elementUi.Switch);
  Vue__default.use(elementUi.Badge);
  Vue__default.use(elementUi.Pagination);
  Vue__default.use(elementUi.Tabs);
  Vue__default.use(elementUi.TabPane);
  Vue__default.use(elementUi.Loading.directive);
  Vue__default.use(elementUi.Checkbox);
  const MsgBox = elementUi.MessageBox;
  Vue__default.prototype.$prompt = MsgBox.prompt;
  Vue__default.prototype.$alert = MsgBox.alert;
  Vue__default.prototype.$message = elementUi.Message;
  Vue__default.prototype.$notify = elementUi.Notification;
  // locale.use(lang)

  Vue__default.use(VJsoneditor);

  var Size;
  (function (Size) {
      Size["BIG"] = "big";
      Size["MEDIUM"] = "medium";
      Size["SMALL"] = "small";
  })(Size || (Size = {}));

  var ButtonTypes;
  (function (ButtonTypes) {
      ButtonTypes["PRIMARY"] = "primary";
      ButtonTypes["SECONDARY"] = "secondary";
      ButtonTypes["TERTIARY"] = "tertiary";
      ButtonTypes["DELETE"] = "delete";
  })(ButtonTypes || (ButtonTypes = {}));
  var ButtonNativeTypes;
  (function (ButtonNativeTypes) {
      ButtonNativeTypes["BUTTON"] = "button";
      ButtonNativeTypes["SUBMIT"] = "submit";
      ButtonNativeTypes["RESET"] = "reset";
  })(ButtonNativeTypes || (ButtonNativeTypes = {}));
  const ButtonSize = Size;

  //
  let MyButton = class MyButton extends vuePropertyDecorator.Vue {
      constructor() {
          super(...arguments);
          this.ButtonTypes = ButtonTypes;
          this.elementIcon = '';
      }
      get computedSize() {
          if (this.size === ButtonSize.BIG ||
              !Object.values(ButtonSize).includes(this.size)) {
              return '';
          }
          return this.size;
      }
      get computedType() {
          if (this.type === ButtonTypes.PRIMARY) {
              return this.type;
          }
          return 'plain';
      }
      get computedClasses() {
          const cssClasses = [];
          if (Object.values(ButtonSize).includes(this.size)) {
              cssClasses.push(this.size);
          }
          if (Object.values(ButtonTypes).includes(this.type)) {
              cssClasses.push(this.type);
          }
          if (this.isLoading) {
              cssClasses.push('loading');
          }
          return cssClasses;
      }
      get availableIcon() {
          if (!this.icon) {
              return '';
          }
          if (this.icon.startsWith('el-')) {
              this.elementIcon = this.icon;
              return '';
          }
          // TODO: add checks for invalid icons
          this.elementIcon = '';
          return `icon-${this.icon}`;
      }
      get isLoading() {
          if (this.type === ButtonTypes.TERTIARY) {
              return false;
          }
          return this.loading;
      }
      handleClick() {
          this.$emit('click');
      }
  };
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: ButtonTypes.PRIMARY, type: String })
  ], MyButton.prototype, "type", void 0);
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: ButtonSize.BIG, type: String })
  ], MyButton.prototype, "size", void 0);
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: '', type: String })
  ], MyButton.prototype, "icon", void 0);
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: false, type: Boolean })
  ], MyButton.prototype, "disabled", void 0);
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: false, type: Boolean })
  ], MyButton.prototype, "loading", void 0);
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: false, type: Boolean })
  ], MyButton.prototype, "autofocus", void 0);
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: '', type: String })
  ], MyButton.prototype, "tooltip", void 0);
  tslib.__decorate([
      vuePropertyDecorator.Prop({ default: ButtonNativeTypes.BUTTON, type: String })
  ], MyButton.prototype, "nativeType", void 0);
  MyButton = tslib.__decorate([
      vuePropertyDecorator.Component
  ], MyButton);
  var script = MyButton;

  function render(_ctx, _cache) {
    const _component_el_button = Vue.resolveComponent("el-button");
    const _component_el_tooltip = Vue.resolveComponent("el-tooltip");

    return (Vue.openBlock(), Vue.createBlock(_component_el_tooltip, {
      content: _ctx.tooltip,
      placement: "right",
      disabled: !_ctx.tooltip
    }, {
      default: Vue.withCtx(() => [
        Vue.createVNode(_component_el_button, {
          type: _ctx.computedType,
          "native-type": _ctx.nativeType,
          size: _ctx.computedSize,
          class: _ctx.computedClasses,
          disabled: _ctx.disabled,
          loading: _ctx.isLoading,
          autofocus: _ctx.autofocus,
          circle: _ctx.type === _ctx.ButtonTypes.TERTIARY,
          icon: _ctx.elementIcon,
          onClick: _cache[1] || (_cache[1] = $event => (_ctx.handleClick($event)))
        }, {
          default: Vue.withCtx(() => [
            (_ctx.availableIcon)
              ? (Vue.openBlock(), Vue.createBlock("i", {
                  key: 0,
                  class: [_ctx.availableIcon]
                }, null, 2 /* CLASS */))
              : Vue.createCommentVNode("v-if", true),
            Vue.renderSlot(_ctx.$slots, "default")
          ]),
          _: 1
        }, 8 /* PROPS */, ["type", "native-type", "size", "class", "disabled", "loading", "autofocus", "circle", "icon"])
      ]),
      _: 1
    }, 8 /* PROPS */, ["content", "disabled"]))
  }

  script.render = render;
  script.__file = "src/components/Button/MyButton.vue";

  function render$1(_ctx, _cache) {
    const _component_el_button_group = Vue.resolveComponent("el-button-group");

    return (Vue.openBlock(), Vue.createBlock(_component_el_button_group, null, {
      default: Vue.withCtx(() => [
        Vue.renderSlot(_ctx.$slots, "default")
      ]),
      _: 1
    }))
  }

  const script$1 = {};


  script$1.render = render$1;
  script$1.__file = "src/components/Button/MyButtonGroup.vue";

  [script, script$1].forEach(element => {
      element.install = function (Vue) {
          Vue.component(element.name, element);
      };
  });

  const components = [
      script,
      script$1
  ];
  const install = function (Vue, opts = {}) {
      components.forEach(component => {
          Vue.component(component.name, component);
      });
  };
  if (typeof window !== 'undefined' && window.Vue) {
      install(window.Vue);
  }
  var index = {
      install,
      MyButton: script,
      MyButtonGroup: script$1
  };

  return index;

}(Vue, elementUi, null, VJsoneditor, null, null, tslib, vuePropertyDecorator));
//# sourceMappingURL=test-ui-ts-lib.min.js.map
